Tools
-------

	* HtmlWriter.cs: it provides a custom HtmlTextWriter implementation with
	logging capabilities to help figuring out which method in HtmlTextWriter
	you should invoke and where to do it.

	How to use it.
	---------------
		* Run 'make'. It will generate HtmlWriter.dll.
		* Copy HtmlWriter.dll to the 'bin' directory.
		* Copy web.config to the directory in which you run xsp
		(the parent of 'bin').
		* There are 2 environment variables used:
			-HTMLWRITER_FULLTRACE=yes: displays the stack trace for
			every method called.
			-HTMLWRITER_FILE=[yourfilename]: output goes to a file
			instead of stdout.

	The default output is a sequence number, the function called and its
	arguments.


	* cache-pq-test-generator: a utility to generate NUnit tests for System.Web.Caching
	  CacheItem priority queue, used to store timed cache items. The utility generates
	  code from sequence files (found in CachePQTestGenerator/Sequences/*.seq) which, in turn
	  are generated by the CacheItemPriorityQueue class itself if System.Web is compiled with
	  the DEBUG macro defined. To generate the sequence files just run your application as usual
	  and at the exit a .seq file will be created in the application's root directory.
	  Copy the generated .seq file to the sequences directory mentioned above and run:

	       make generate-cache-pq-tests

	  which will generate the ../System.Web.Caching/CacheItemPriorityQueueTest_generated.cs file
